﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MyMVCApplication.Models;
using MyMVCApplication.Services;

namespace MyMVCApplication.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        private StockService _stockService = null;
        private ImageService _imageService = null; 

        public HomeController()
        {
            _stockService = new StockService();
            _imageService = new ImageService();
        }

        public ActionResult Index()
        {
           ViewData["Slides"] = _imageService.GetAll(); 

            

            ViewData["Message"] = "Welcome to ASP.NET MVC!";
            return View();
        }

        public ActionResult About()
        {
            return View();
        }

        public ActionResult ValidationUsingIDataErrorInfo(Customer customer)
        {
            if (!ModelState.IsValid)
                return View("ValidationUsingIDataErrorInfo"); 

            return View("Confirmation"); 
        }

        public ActionResult SimpleValidation(Customer customer)
        {
            if(String.IsNullOrEmpty(customer.FirstName)) 
                ModelState.AddModelError("FirstName","FirstName cannot be blank!");

            if(String.IsNullOrEmpty(customer.LastName)) 
                ModelState.AddModelError("LastName","LastName cannot be blank!");

            if (!ModelState.IsValid)
                return View("SimpleValidation"); 

            return View("Confirmation"); 
        }

        public ActionResult Save(Customer customer)
        {
            if (!ModelState.IsValid)
                return View("New"); 

            return View("Confirmation"); 
        }

        public ActionResult LatestStockUpdates()
        {
            var stocks = _stockService.GetLatest();

            if(stocks == null) return null; 
            
            ViewData["Stocks"] = stocks; 

            return View("LatestStocks",ViewData["Stocks"]);
        }

        public ActionResult New()
        {
            return View(new Customer()); 
        }
    }
}
