﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;
using MyMVCApplication.Models;

namespace MyMVCApplication
{
    public static class ExtensionMethods
    {
       public static TagBuilder FluentTextBox(this HtmlHelper htmlHelper,string name, string value)
       {
           var tagBuilder = new TagBuilder("input");
           tagBuilder.Attributes["name"] = name;
           tagBuilder.Attributes["id"] = name;
           tagBuilder.Attributes["value"] = value;
           return tagBuilder; 
       }

        public static TagBuilder OnFocus(this TagBuilder tagBuilder, string script)
        {
            tagBuilder.MergeAttribute("onfocus",script);
            return tagBuilder; 
        }

        public static TagBuilder OnBlur(this TagBuilder tagBuilder, string script)
        {
            tagBuilder.MergeAttribute("onblur",script);
            return tagBuilder; 
        }

        public static string Captcha(this HtmlHelper htmlHelper, string name)
        {
            var tagBuilder = new TagBuilder("DIV");  
            return String.Empty; 
        }

        public static string ImageList(this HtmlHelper htmlHelper, string name, IList<SlideImage> slides)
        {
            var html = new StringBuilder(); 

            var tagBuilder = new TagBuilder("DIV");

            html.Append(tagBuilder.ToString()); 

            foreach(var slide in slides)
            {
                var tb = new TagBuilder("IMG"); 
                tb.MergeAttribute("src",slide.Url);
                tb.MergeAttribute("width","100px"); 
                tb.MergeAttribute("height","100px");

                html.Append(tb.ToString()); 
            }

            // the helper might be too complicated to use for the slide show scenario!!!! 

            return html.ToString(); 
        }


    }
}
